merged = LibStub("AceAddon-3.0"):NewAddon("merged", "AceConsole-3.0", "AceComm-3.0", "AceEvent-3.0")

function merged:OnInitialize()
   -- Code that you want to run when the addon is first loaded goes here.
   
   -- Register LibDeformat  
   deformat = LibStub("LibDeformat-3.0")
   
   
   -- Register Events      
   merged:RegisterEvent("CHAT_MSG_LOOT", "mergedEventHandler")
   
   -- Register DB
   self.db = LibStub("AceDB-3.0"):New("mergedDB",{
		profile = {
			minimap = {
				hide = false,
			},
		},
	})
	
   
   -- Register LDB
   local LDB = LibStub("LibDataBroker-1.1"):NewDataObject("merged", {
	type = "data source",
	text = "merged",
	icon = "Interface\\Icons\\Achievement_Boss_Sindragosa",
	--OnClick = function() merged:MinimapClick() end,
	OnTooltipShow = function(tooltip) 
   tooltip:AddLine('merged Flask Check')
   tooltip:AddLine('Version: '..self.db.global.merged_version)
   tooltip:AddLine('|cffffff00RightClick: Version Check|r')
   tooltip:AddLine('|cffffff00Shift LeftClick: Reset Flasks|r')
   tooltip:AddLine('|cffffff00LeftClick: Flask Check|r')
   end,
   })
   
   function LDB.OnClick(self, button)
	if button == "RightButton" then	   
		  merged:PrintVersion()
	else
		if IsShiftKeyDown() then
			merged:ResetFlasks()
		else
			merged:PrintFlasks()
		end
	end
end
   
   -- Minimap Icon
   local icon = LibStub("LibDBIcon-1.0")
   icon:Register("merged", LDB, self.db.profile.minimap)
   
   -- Register Comms
   merged:RegisterComm("merged_version_check", "mergedVersionHandler")
   merged:RegisterComm("merged_version_result", "mergedVersionHandler")
   merged:RegisterComm("merged_flask", "mergedCommHandler")
   
   -- Register Slashs
   merged:RegisterChatCommand("flaskv", "PrintVersion")  
   merged:RegisterChatCommand("flaskr", "ResetFlasks")
   merged:RegisterChatCommand("flaskf", "PrintFlasks")
   
   -- Variables
   self.db.global.merged_version = "22"
	self.db.global.welcome = "merged loaded"
	
	
	self.db.global.colors = {}
	self.db.global.colors.red = "|cffff2020"
	self.db.global.colors.green = "|cff20ff20"
	self.db.global.colors.yellow = "|cffffff00"
	self.db.global.colors.gray = "|cff808080"
	
	self.db.global.debug = false
	
	
	--self.db.global.roster.Shesu = { "version", "flask"}
	--self.db.global.roster.Nahuel = { "version", "flask"}
end

function merged:OnEnable()
    -- Called when the addon is enabled
    
   self:RegisterEvent("UNIT_PET", "UpdateRoster")
	self:RegisterEvent("PARTY_MEMBERS_CHANGED", "UpdateRoster")
	self:RegisterEvent("RAID_ROSTER_UPDATE", "UpdateRoster")

	self:RegisterEvent("UNIT_NAME_UPDATE", "UpdateRoster")
	self:RegisterEvent("UNIT_PORTRAIT_UPDATE", "UpdateRoster")
end

function merged:OnDisable()
    -- Called when the addon is disabled
end
   
  



function merged:CheckVersion()
    -- Version Check
    merged:DebugPrint("CheckVersion Called")
    if(GetRealNumRaidMembers() > 0) then
      merged:SendCommMessage("merged_version_check", "true", "RAID")
    end
    --merged:SendCommMessage("merged_version_check", "true", "GUILD")
    
end

function merged:mergedVersionHandler(prefix, message, distribution, sender)
    -- processing version checks
    merged:DebugPrint("Prefix: "..prefix.." message: "..message.." Dis: "..distribution.." sender: "..sender)
    if(prefix == "merged_version_check") then 
      merged:DebugPrint("Attempt to Send Message: "..self.db.global.merged_version.." to: "..sender)
      merged:SendCommMessage("merged_version_result", self.db.global.merged_version, "WHISPER", sender)    
    end
    
    if(prefix == "merged_version_result") then
      merged:DebugPrint("Your Version: "..self.db.global.merged_version.." "..sender.." Version: "..message)
      --merged:DebugPrint(self.db.global.roster[sender].version)
      --self.db.global.roster[sender].version = message
      self.db.global.roster[sender].version = message
      --merged:PrintVersion()
    end

end 

function merged:mergedCommHandler(prefix, message, distribution, sender)
    -- processing flask events
    merged:DebugPrint("Prefix: "..prefix.." message: "..message.." Dis: "..distribution.." sender: "..sender)
    
    if(prefix == "merged_flask") then 
      merged:DebugPrint("Flask erhalten: "..sender) -- debug
      self.db.global.roster[sender].flask = self.db.global.roster[sender].flask+1
    end
end

function merged:mergedEventHandler(eventName, arg1)
    -- Called by Events! Handle it!
    merged:DebugPrint("Event: "..eventName.." arg1: "..arg1)
         
    itemlink = deformat(arg1, LOOT_ITEM_PUSHED_SELF)
    if itemlink then    
      local justItemId = string.gsub(itemlink,".-\124H([^\124]*)\124h.*", "%1");	
      local type, itemid, enchantId, jewelId1, jewelId2, jewelId3, jewelId4, suffixId, uniqueId = strsplit(":",justItemId); 
      if(itemid == "65455") then 
         merged:SendCommMessage("merged_flask", "true", "RAID")
      end
    end
end

function merged:PrintVersion()
    -- Print Info from the Version Table
    merged:DebugPrint("Print Version Called")
    version_number = self.db.global.merged_version
    merged:DebugPrint("Local Version: "..version_number)
    output_var_3 = "Version Info: "..self.db.global.colors.red.." unknown or older|r "..self.db.global.colors.yellow.." new|r "..self.db.global.colors.green.." same|r Version"
    output_var_4 = ""
    
    if GetNumRaidMembers() > 0 then
      for i = 1 , 40 do 
        name = (UnitName("raid"..i))
        if(name) then
            merged:DebugPrint("Name: "..name)
            if(self.db.global.roster[name].version) then
               check_vers = self.db.global.roster[name].version
               merged:DebugPrint(name.." Version: "..check_vers)
            else
               check_vers = 1
            end
        
            version_number = tonumber(version_number)
            check_vers = tonumber(check_vers)
            if(version_number == check_vers) then
               output_var_4 = output_var_4..self.db.global.colors.green..name.."|r "
            elseif(version_number < check_vers) then
               output_var_4 = output_var_4..self.db.global.colors.yellow..name.."|r "
            else
               output_var_4 = output_var_4..self.db.global.colors.red..name.."|r "
            end
         end
      end 
      merged:Print(output_var_3)
      merged:Print(output_var_4)
    else 
      merged:DebugPrint("No Raid")
    end
    
    
end

function merged:PrintFlasks()
    -- Print Info from the Flask Table
    merged:DebugPrint("Print Flask Called")
    output_var_1 = "Flask Check: "..self.db.global.colors.gray.." none|r "..self.db.global.colors.green.." one|r "..self.db.global.colors.red.." two or more|r Flasks"
    output_var_2 = ""
    if GetNumRaidMembers() > 0 then
      for i = 1 , 40 do 
        name = (UnitName("raid"..i))
        if(name) then 
            if(self.db.global.roster[name].flask == 0) then 
               output_var_2 = output_var_2..self.db.global.colors.gray..name.."|r "
            end
            if(self.db.global.roster[name].flask == 1) then 
               output_var_2 = output_var_2..self.db.global.colors.green..name.."|r "
            end
            if(self.db.global.roster[name].flask >= 2) then 
               output_var_2 = output_var_2..self.db.global.colors.red..name.."|r "
            end  
         end
      end 
      merged:Print(output_var_1)
      merged:Print(output_var_2)
   else
      merged:DebugPrint("no raid")
   end
end

function merged:ResetFlasks()
    -- Sets all Flasks Lootet to Zero
    merged:DebugPrint("Reset Flask Called")
    if GetNumRaidMembers() > 0 then
      for i = 1 , 40 do 
         name = (UnitName("raid"..i))
         if(name) then
            merged:DebugPrint("name: "..name)
            self.db.global.roster[name].flask = 0
         end
      end  
    end
end


function merged:ResetTables()
   self.db.global.roster = {}
end

function merged:DebugPrint(msg)
   if(self.db.global.debug and msg) then merged:Print(self.db.global.colors.green.."Debug: "..msg.."|r") end
end

function merged:Print_r(tab)
   for k,v in pairs(tab) do print(k,v) end
end



function merged:UpdateRoster()
   if(not self.db.global.roster) then 
      merged:ResetTables() 
   end
   if GetNumRaidMembers() > 0 then
      merged:DebugPrint("UpdateRoster Started...")
      for i = 1, 40 do
         if(not self.db.global.roster[(UnitName("raid"..i))] and (UnitName("raid"..i))) then
            self.db.global.roster[(UnitName("raid"..i))] = { ["version"] = 0, ["flask"] = 0}
         end      
      end    
         merged:CheckVersion()
   end
end

